// Copyright 2020 the Pinniped contributors. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "go.pinniped.dev/generated/1.17/apis/supervisor/idp/v1alpha1"
	scheme "go.pinniped.dev/generated/1.17/client/supervisor/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// UpstreamOIDCProvidersGetter has a method to return a UpstreamOIDCProviderInterface.
// A group's client should implement this interface.
type UpstreamOIDCProvidersGetter interface {
	UpstreamOIDCProviders(namespace string) UpstreamOIDCProviderInterface
}

// UpstreamOIDCProviderInterface has methods to work with UpstreamOIDCProvider resources.
type UpstreamOIDCProviderInterface interface {
	Create(*v1alpha1.UpstreamOIDCProvider) (*v1alpha1.UpstreamOIDCProvider, error)
	Update(*v1alpha1.UpstreamOIDCProvider) (*v1alpha1.UpstreamOIDCProvider, error)
	UpdateStatus(*v1alpha1.UpstreamOIDCProvider) (*v1alpha1.UpstreamOIDCProvider, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.UpstreamOIDCProvider, error)
	List(opts v1.ListOptions) (*v1alpha1.UpstreamOIDCProviderList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.UpstreamOIDCProvider, err error)
	UpstreamOIDCProviderExpansion
}

// upstreamOIDCProviders implements UpstreamOIDCProviderInterface
type upstreamOIDCProviders struct {
	client rest.Interface
	ns     string
}

// newUpstreamOIDCProviders returns a UpstreamOIDCProviders
func newUpstreamOIDCProviders(c *IDPV1alpha1Client, namespace string) *upstreamOIDCProviders {
	return &upstreamOIDCProviders{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the upstreamOIDCProvider, and returns the corresponding upstreamOIDCProvider object, and an error if there is any.
func (c *upstreamOIDCProviders) Get(name string, options v1.GetOptions) (result *v1alpha1.UpstreamOIDCProvider, err error) {
	result = &v1alpha1.UpstreamOIDCProvider{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of UpstreamOIDCProviders that match those selectors.
func (c *upstreamOIDCProviders) List(opts v1.ListOptions) (result *v1alpha1.UpstreamOIDCProviderList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.UpstreamOIDCProviderList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested upstreamOIDCProviders.
func (c *upstreamOIDCProviders) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a upstreamOIDCProvider and creates it.  Returns the server's representation of the upstreamOIDCProvider, and an error, if there is any.
func (c *upstreamOIDCProviders) Create(upstreamOIDCProvider *v1alpha1.UpstreamOIDCProvider) (result *v1alpha1.UpstreamOIDCProvider, err error) {
	result = &v1alpha1.UpstreamOIDCProvider{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		Body(upstreamOIDCProvider).
		Do().
		Into(result)
	return
}

// Update takes the representation of a upstreamOIDCProvider and updates it. Returns the server's representation of the upstreamOIDCProvider, and an error, if there is any.
func (c *upstreamOIDCProviders) Update(upstreamOIDCProvider *v1alpha1.UpstreamOIDCProvider) (result *v1alpha1.UpstreamOIDCProvider, err error) {
	result = &v1alpha1.UpstreamOIDCProvider{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		Name(upstreamOIDCProvider.Name).
		Body(upstreamOIDCProvider).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *upstreamOIDCProviders) UpdateStatus(upstreamOIDCProvider *v1alpha1.UpstreamOIDCProvider) (result *v1alpha1.UpstreamOIDCProvider, err error) {
	result = &v1alpha1.UpstreamOIDCProvider{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		Name(upstreamOIDCProvider.Name).
		SubResource("status").
		Body(upstreamOIDCProvider).
		Do().
		Into(result)
	return
}

// Delete takes name of the upstreamOIDCProvider and deletes it. Returns an error if one occurs.
func (c *upstreamOIDCProviders) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *upstreamOIDCProviders) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched upstreamOIDCProvider.
func (c *upstreamOIDCProviders) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.UpstreamOIDCProvider, err error) {
	result = &v1alpha1.UpstreamOIDCProvider{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("upstreamoidcproviders").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
